// WndSubclass.cpp : Implementation of CWndSubclass
// :   aKa WiRuc

/*	      ,  .
	       .

	 :
	set procedure to wndproc.prg  //      WndProc(hWnd, uMsg, wParam, lParam)
	//  :  ,  , WPARAM, LPARAM

	o = createobject("FoxSubclass.WndSubclass")
	o.pFoxDispatch = _vfp //     
	o.SubclassWindow(_vfp.hWnd, "WndProc", .F.)  //     ,
												//    WndProc,
												//    ,    AddMessage
	o.AddMessage(_vfp.hWnd, 6, 0)	//   WM_ACTIVATE   ,
									//       

	o.UnSubclassWindow(_vfp.hWnd)	//   

	 IsHandled  ,           .
	 ,          .
	 IsHandled = .F.,        ,  .T. -  
	(,    AddMessage   uPlace = 2 (      ))

	          ChangeMessageParam()
*/

#include "stdafx.h"
#include "WndSubclass.h"

// CWndSubclass
// static members
CSimpleMap<HWND, SUBCLASSINFO> CWndSubclass::m_mapSubclass;
IDispatch* CWndSubclass::m_pFoxDispatch = NULL;
DISPID CWndSubclass::m_dispidEval;

// Main subclass procedure
LRESULT CALLBACK CWndSubclass::FoxSubclassProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	// Get subclass structure from static map
	ATLASSERT(m_mapSubclass.FindKey(hWnd)<0);
	SUBCLASSINFO& si = m_mapSubclass.GetValueAt(m_mapSubclass.FindKey(hWnd));

	// Save current message
	si.pWnd->m_msg.hwnd=hWnd;
	si.pWnd->m_msg.message=uMsg;
	si.pWnd->m_msg.wParam=wParam;
	si.pWnd->m_msg.lParam=lParam;

	si.pWnd->m_bIsHandled = false;	// message not handled

	TCHAR buf[50];
	wsprintf(buf, _T("(%u,%u,%u,%u)"), (UINT)hWnd, uMsg, wParam, lParam);
	//       : handler(hWnd, msg, wparam, lparam)
	
	CComBSTR bstrEval(si.bstrMsgHandler);
	bstrEval.Append(buf);

	VARIANT varResult;
	LRESULT lResult = 0;

	if (si.bReceiveAll)  // Receive all message (NOT RECOMMENDED, VERY SLOW)
	{
		FoxEval(bstrEval, varResult);  // pass message to FoxPro handler

		if (si.pWnd->m_bIsHandled && varResult.vt == VT_I4)
			lResult = varResult.lVal;
	}
	else
	{
		for(int i=0; i<si.arrMsg.GetSize(); i++)
		{
			if (si.arrMsg[i].uMsg == uMsg)  //   
			{
				UINT uPlace = si.arrMsg[i].uPlace;

				if (uPlace == 0 || uPlace == 2)  //     ?
					FoxEval(bstrEval, varResult);

				if (si.pWnd->m_bIsHandled)
					if (varResult.vt == VT_I4)
						lResult = varResult.lVal; 
				else
				{
					lResult = ::CallWindowProc(si.pfnOldWndProc, hWnd, uMsg, si.pWnd->m_msg.wParam, si.pWnd->m_msg.lParam);
					si.pWnd->m_bIsHandled = true;
				}
					
				if (uPlace == 1 || uPlace == 2)
				{
					FoxEval(bstrEval, varResult);
					si.pWnd->m_bIsHandled = true;  // needed to prevent from second call CallWindowProc
				}				
				break;
			}
		}
	}

	if (!si.pWnd->m_bIsHandled)  //    
		lResult = ::CallWindowProc(si.pfnOldWndProc, hWnd, uMsg, si.pWnd->m_msg.wParam, si.pWnd->m_msg.lParam);

	if (uMsg == WM_DESTROY || uMsg == WM_NCDESTROY)  // window destroy, auto unsubclass done
		si.pWnd->UnSubclassWindow((OLE_HANDLE)hWnd);

	si.pWnd->m_msg.hwnd = 0;  // no current message
	return lResult;
}

bool CWndSubclass::FoxEval(BSTR bstrExec, VARIANT& varResult)
{
	if (m_pFoxDispatch == NULL)
		return false;

	HRESULT hr;
	EXCEPINFO ExcepInfo;
	VARIANTARG varArg;
	varArg.vt = VT_BSTR;
	varArg.bstrVal = bstrExec;

	DISPPARAMS DispParams;
	ZeroMemory(&DispParams, sizeof(DISPPARAMS));
	DispParams.cArgs = 1;
	DispParams.rgvarg = &varArg;

	VariantInit(&varResult);

	hr = m_pFoxDispatch->Invoke(m_dispidEval,IID_NULL,LOCALE_SYSTEM_DEFAULT,DISPATCH_METHOD,&DispParams,&varResult,&ExcepInfo,NULL);

	return SUCCEEDED(hr);
}

STDMETHODIMP CWndSubclass::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IWndSubclass
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CWndSubclass::SubclassWindow(OLE_HANDLE hWnd, BSTR bstrMsgHandler, VARIANT_BOOL bReceiveAll, VARIANT_BOOL* bRet)
{
	if (bRet == NULL || bstrMsgHandler == NULL)
		return E_POINTER;

	*bRet = VARIANT_FALSE;

	//   pFoxDispatch      
	if (m_pFoxDispatch == NULL)
	{
		// Send exception to automation client
		AtlReportError(GetObjectCLSID(), IDS_ERROR_FOX_NOT_ATTACH);
		return DISP_E_EXCEPTION;
	}

	VARIANT varResult;
	CComBSTR bstr(bstrMsgHandler);
	bstr.Append(_T("(0, 0, 0, 0)"));

	//     
	if (!FoxEval(bstr, varResult))
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_FOXEVAL);
		return DISP_E_EXCEPTION;
	}

	if (m_mapSubclass.FindKey((HWND)hWnd)>=0)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_ALREADY_SUBCLASSED);
		return DISP_E_EXCEPTION;
	}

	if (!::IsWindow((HWND)hWnd))
		return S_FALSE;

	//   
	WNDPROC pfnOldWndProc = (WNDPROC)::SetWindowLong((HWND)hWnd, GWL_WNDPROC, (LONG)CWndSubclass::FoxSubclassProc);

	if (pfnOldWndProc != 0)
	{
		SUBCLASSINFO si;
		si.bReceiveAll = bReceiveAll;
		si.pfnOldWndProc = pfnOldWndProc;
		si.bstrMsgHandler.Attach(bstrMsgHandler);
		si.pWnd = this;

		*bRet = m_mapSubclass.Add((HWND)hWnd, si) ? VARIANT_TRUE:VARIANT_FALSE;
	}

	return *bRet ? S_OK:S_FALSE;
}

STDMETHODIMP CWndSubclass::AddMessage(OLE_HANDLE hWnd, ULONG uMsg, BYTE uPlace, VARIANT_BOOL* bRet)
{
	if (bRet == NULL)
		return E_POINTER;

	*bRet = VARIANT_FALSE;

	if (uPlace>2)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_MSG_PLACE_RANGE);
		return DISP_E_EXCEPTION;
	}

	if (m_mapSubclass.FindKey((HWND)hWnd)<0)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_NOT_SUBCLASSED);
		return DISP_E_EXCEPTION;
	}

	SUBCLASSINFO& si = m_mapSubclass.GetValueAt(m_mapSubclass.FindKey((HWND)hWnd));

	if (si.bReceiveAll) // receive all messages, use AddMessage is incorrect
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_ADDMESSAGE_INCORRECT);
		return DISP_E_EXCEPTION;
	}

	//     ?
	for (int i=0; i<si.arrMsg.GetSize(); i++)
	{
		if (si.arrMsg[i].uMsg == uMsg)
		{
			AtlReportError(GetObjectCLSID(), IDS_ERROR_MESSAGE_EXIST);
			return DISP_E_EXCEPTION;
		}
	}

	MSGINFO mi;
	mi.uMsg = uMsg;
	mi.uPlace = uPlace;

	*bRet = si.arrMsg.Add(mi) ? VARIANT_TRUE:VARIANT_FALSE; 

	return *bRet ? S_OK:S_FALSE;
}

STDMETHODIMP CWndSubclass::RemoveMessage(OLE_HANDLE hWnd, ULONG uMsg)
{
	if (m_mapSubclass.FindKey((HWND)hWnd)<0)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_NOT_SUBCLASSED);
		return DISP_E_EXCEPTION;
	}
	
	SUBCLASSINFO& si = m_mapSubclass.GetValueAt(m_mapSubclass.FindKey((HWND)hWnd));

	if (si.pWnd != this)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_NOT_SUBCLASSED);
		return DISP_E_EXCEPTION;
	}

	bool bRemoved = false;

	for(int i = 0; i<si.arrMsg.GetSize(); i++)
	{
		if (si.arrMsg[i].uMsg == uMsg)
		{			
			bRemoved = si.arrMsg.RemoveAt(i);
			break;
		}
	}

	if (!bRemoved)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_MESSAGE_NOT_EXIST);
		return DISP_E_EXCEPTION;
	}

	return S_OK;
}

STDMETHODIMP CWndSubclass::RemoveMessageAll(OLE_HANDLE hWnd)
{
	int iIndex = m_mapSubclass.FindKey((HWND)hWnd);

	if (iIndex<0 || m_mapSubclass.GetValueAt(iIndex).pWnd != this)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_NOT_SUBCLASSED);
		return DISP_E_EXCEPTION;
	}

	m_mapSubclass.GetValueAt(iIndex).arrMsg.RemoveAll();

	return S_OK;
}

STDMETHODIMP CWndSubclass::UnSubclassWindow(OLE_HANDLE hWnd)
{
	int iIndex = m_mapSubclass.FindKey((HWND)hWnd);

	if (iIndex<0 || m_mapSubclass.GetValueAt(iIndex).pWnd != this)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_NOT_SUBCLASSED);
		return DISP_E_EXCEPTION;
	}

	LONG lProc = ::SetWindowLong((HWND)hWnd, GWL_WNDPROC, (LONG)m_mapSubclass.GetValueAt(iIndex).pfnOldWndProc);

	return m_mapSubclass.RemoveAt(iIndex) && lProc!=0 ? S_OK:E_FAIL;
}

STDMETHODIMP CWndSubclass::ChangeMessageParam(ULONG wParam, ULONG lParam)
{
	if (m_msg.hwnd == 0)
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_MESSAGE_NOT_IN_PROGRESS);
		return DISP_E_EXCEPTION;
	}

	m_msg.wParam = wParam;
	m_msg.lParam = lParam;

	return S_OK;
}

STDMETHODIMP CWndSubclass::get_IsHandled(VARIANT_BOOL* pVal)
{
	if (pVal == NULL)
		return E_POINTER;

	*pVal = m_bIsHandled ? VARIANT_TRUE:VARIANT_FALSE;
	return S_OK;
}

STDMETHODIMP CWndSubclass::put_IsHandled(VARIANT_BOOL newVal)
{
	m_bIsHandled = (newVal != VARIANT_FALSE);
	return S_OK;
}

STDMETHODIMP CWndSubclass::get_pFoxDispatch(IDispatch** pVal)
{
	if (pVal == NULL)
		return E_POINTER;

	*pVal = m_pFoxDispatch;
	return S_OK;
}

STDMETHODIMP CWndSubclass::put_pFoxDispatch(IDispatch* newVal)
{
	if (newVal == NULL)
		return E_POINTER;

	OLECHAR FAR* szEvalMethod = OLESTR("Eval");
	DISPID dispid;

	if (FAILED(newVal->GetIDsOfNames(IID_NULL,&szEvalMethod,1,LOCALE_SYSTEM_DEFAULT,&dispid)))
	{
		AtlReportError(GetObjectCLSID(), IDS_ERROR_METHOD_NOT_FOUND);
		return DISP_E_EXCEPTION;
	}

	m_pFoxDispatch = newVal;
	m_dispidEval = dispid;

	return S_OK;
}
