// WndSubclass.h : Declaration of the CWndSubclass

#pragma once
#include "resource.h"       // main symbols
#include "FoxSubclass.h"

class ATL_NO_VTABLE CWndSubclass;  // forward declaration

typedef struct _MSGINFO
{	
	UINT uMsg;
	BYTE uPlace;
}MSGINFO;

typedef struct _SUBCLASSINFO
{	
	CSimpleArray<MSGINFO> arrMsg;
	BOOL bReceiveAll;
	CComBSTR bstrMsgHandler;
	WNDPROC pfnOldWndProc;
	CWndSubclass* pWnd;
}SUBCLASSINFO;

// CWndSubclass
class ATL_NO_VTABLE CWndSubclass : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CWndSubclass, &CLSID_WndSubclass>,
	public ISupportErrorInfoImpl<&IID_IWndSubclass>,
	public IDispatchImpl<IWndSubclass, &IID_IWndSubclass, &LIBID_FoxSubclassLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CWndSubclass()
	{}

DECLARE_REGISTRY_RESOURCEID(IDR_WNDSUBCLASS)
DECLARE_NOT_AGGREGATABLE(CWndSubclass)

BEGIN_COM_MAP(CWndSubclass)
	COM_INTERFACE_ENTRY(IWndSubclass)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		ZeroMemory(&m_msg, sizeof(m_msg));
		return S_OK;
	}
	
	void FinalRelease() 
	{
		for(int i=0; i<m_mapSubclass.GetSize(); i++)
		{
			if (m_mapSubclass.GetValueAt(i).pWnd == this)
				UnSubclassWindow((OLE_HANDLE)m_mapSubclass.GetKeyAt(i));
		}
	}

public:

	STDMETHOD(SubclassWindow)(OLE_HANDLE hWnd, BSTR bstrMsgHandler, VARIANT_BOOL bReceiveAll, VARIANT_BOOL* bRet);
	STDMETHOD(AddMessage)(OLE_HANDLE hWnd, ULONG uMsg, BYTE uPlace, VARIANT_BOOL* bRet);
	STDMETHOD(RemoveMessage)(OLE_HANDLE hWnd, ULONG uMsg);
	STDMETHOD(UnSubclassWindow)(OLE_HANDLE hWnd);
	STDMETHOD(RemoveMessageAll)(OLE_HANDLE hWnd);
	STDMETHOD(ChangeMessageParam)(ULONG wParam, ULONG lParam);
	STDMETHOD(get_IsHandled)(VARIANT_BOOL* pVal);
	STDMETHOD(put_IsHandled)(VARIANT_BOOL newVal);
	STDMETHOD(get_pFoxDispatch)(IDispatch** pVal);
	STDMETHOD(put_pFoxDispatch)(IDispatch* newVal);
	static bool FoxEval(BSTR bstrExec, VARIANT& varResult);

protected:

	static LRESULT CALLBACK FoxSubclassProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	static IDispatch* m_pFoxDispatch;
	static DISPID m_dispidEval;
	static CSimpleMap<HWND, SUBCLASSINFO> m_mapSubclass; // static subclass map
	bool m_bIsHandled; // TRUE - message handled, FALSE - not yet
	MSG m_msg; // current message
};

OBJECT_ENTRY_AUTO(__uuidof(WndSubclass), CWndSubclass)
